import * as cdk8s from 'cdk8s';
import { Construct } from 'constructs';
/**
 * (experimental) Initialization properties for resources.
 *
 * @experimental
 */
export interface ResourceProps {
    /**
     * (experimental) Metadata that all persisted resources must have, which includes all objects users must create.
     *
     * @experimental
     */
    readonly metadata?: cdk8s.ApiObjectMetadata;
}
/**
 * (experimental) Represents a resource.
 *
 * @experimental
 */
export interface IResource {
    /**
     * (experimental) The Kubernetes name of this resource.
     *
     * @experimental
     */
    readonly name: string;
}
/**
 * (experimental) Base class for all Kubernetes objects in stdk8s.
 *
 * Represents a single
 * resource.
 *
 * @experimental
 */
export declare abstract class Resource extends Construct implements IResource {
    /**
     * (experimental) The underlying cdk8s API object.
     *
     * @experimental
     */
    protected abstract readonly apiObject: cdk8s.ApiObject;
    /**
     * @experimental
     */
    constructor(scope: Construct, id: string, _: ResourceProps);
    /**
     * @experimental
     */
    get metadata(): cdk8s.ApiObjectMetadataDefinition;
    /**
     * (experimental) The name of this API object.
     *
     * @experimental
     */
    get name(): string;
}
